article/urls.py
from django.urls import include, path
from .views import index, singlePost, add_article, adminView, delete_post, edit_post
from django.conf import settings
from django.conf.urls.static import static
from django.conf import settings

urlpatterns = [
	path('', index, name='index'),
    path('add', add_article, name='add'),
    path('artikel/<int:id>', singlePost, name='singlePost'),

    path('admin_view', adminView, name='admin_view'),
    path('delete_post', delete_post, name='delete_post'),
    path('edit/<int:id>', edit_post, name='edit'),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

home/home/urls.py
from django.contrib import admin
from django.urls import path

urlpatterns = [
    path('admin/', admin.site.urls),
]

tkpbp/urls.py
from django.urls import include, path, re_path
from django.contrib import admin
from article.views import index as index_article
import article.urls as article
import accounts.urls as accounts
from django.conf import settings
from django.conf.urls.static import static
urlpatterns = [
    path('admin/', admin.site.urls),
    path('',include(accounts)),
    path('artikel/', include(('article.urls','article'), namespace='article')),
    # re_path(r'^$', index_article, name='index'),


]
if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

article/models.py
from django.db import models
from django.utils.text import slugify
# Create your models here.
class Article(models.Model):
    id=models.AutoField(primary_key=True)
    title = models.CharField(max_length = 100)
    author = models.CharField(max_length=50)
    date = models.DateTimeField(auto_now=True)
    desc = models.CharField(max_length = 300)
    article = models.TextField()
    photo = models.ImageField(upload_to='images/')

    def __str__(self):
        return self.title

    def delete(self, *args, **kwargs):
        super().delete(*args, **kwargs)

article/forms.py
from django import forms
from.models import Article

class ArticleForm(forms.ModelForm):
    class Meta:
        model = Article
        fields = "__all__"
        exclude = ['id']
        

article/views.py
from django.http import HttpResponse, JsonResponse
from django.shortcuts import render, redirect
from .models import Article
from .forms import ArticleForm
from django.contrib.auth.decorators import login_required
from django.views.decorators.csrf import csrf_exempt
from django.contrib.auth import get_user, login, logout,authenticate

def stringpurifier(words):
    newStr = ""
    for i in words:
        if i != " " or i != "\n":
            newStr += i
    return(" ".join(newStr.split()))

# Create your views here.
def index(request):
    article = Article.objects.all().values()
    response = {'article':article,'nbar':'Artikel'}
    return render(request, 'article_index.html', response)


def add_article(request):
    if request.user.is_authenticated and (request.user.is_counselor or request.user.is_staff or request.user.is_superuser):
        form = ArticleForm(request.POST or None, request.FILES or None)
        if form.is_valid():
            form.save()
            return redirect('..')
        return render(request, "article_add.html", {'form': form})
    else:
        return redirect('../artikel')

def singlePost(request, id):
    post = Article.objects.get(id=id)
    response = {'post':post}
    return render(request, "single_article.html", response)

def adminView(request):
    if request.user.is_authenticated and (request.user.is_counselor or request.user.is_staff or request.user.is_superuser):
        article = Article.objects.all().values()
        response = {'article':article}
        return render(request, 'admin_view.html', response)
    else:
        return redirect('../artikel')
    
@csrf_exempt
def delete_post(request):
    title=stringpurifier(request.POST.get("title")) 
    try:
        Article.objects.get(title=title).delete()
        article_data={"error":False,"errorMessage":"Deleted Successfully", "title":title}
        return JsonResponse(article_data,safe=False)
    except:
        article_data={"error":True,"errorMessage":"Failed to Delete Data", "title":title}
        return JsonResponse(article_data,safe=False)

def edit_post(request, id):
    if request.user.is_authenticated and (request.user.is_counselor or request.user.is_staff or request.user.is_superuser):
        post = Article.objects.get(id=id)
        if request.method == 'POST':
            form = ArticleForm(request.POST, instance=post)
            if form.is_valid():
                form.save()
                return adminView(request)
        else:
            form = ArticleForm(instance=post)
        return render(request, "article_add.html", {'form': form})
    else:
        return redirect('../artikel')

article/templates/admin_view.html
{% extends 'base.html' %}
{% load static %}
<!doctype html>
<html lang="en">
  <head>
    {% block css %}
    {{block.super}}
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <link rel="stylesheet" href="{% static 'css/admin_view.css' %}">
    <script src="{% static 'js/admin_view.js' %}"></script>
    {% endblock %}
  </head>
  {% block body %}
  {{block.super}}
  <br>
  <br>
  <div class="content">
        <h2>Daftar artikel saat ini</h2>
        <div class="tableBack">
            <div class="table">
                <table>
                    <tr>
                        <th>Judul</th>
                        <th>Author</th>
                        <th>Waktu Publikasi</th>
                        <th>Deskripsi Artikel</th>
                        <th>Action</th>
                    </tr>
                    {% for i in article %}
                    <tr>
                        <td>
                            {{i.title}}
                        </td>
                        <td>
                            {{i.author}}
                        </td>
                        <td>
                            {{i.date}}
                        </td>
                        <td>
                            {{i.desc}}
                        </td>
                        <td>
                            <a href="{% url 'article:singlePost' id=i.id  %}" class="btn btn-success btn-sm">detail</a>
                            <a href="{% url 'article:edit' id=i.id  %}" class="btn btn-warning btn-sm">edit</a>
                            <button class="btn btn-block btn-delete btn-danger btn-sm">delete</button>
                        </td>
                    </tr>
                    {% endfor %}
                </table>
            </div>
        </div>
    </div>

  {% endblock %}
</html>

article/templates/article_add.html
{% extends 'base.html' %}
{% load static %}
<!DOCTYPE html>
<html lang="en">
    <head>
        {% block css %}
        {{block.super}}
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
        <script src="{% static 'js/article_add.js' %}"></script>
        <link rel="stylesheet" href="{% static 'css/article_add.css' %}">
        {% endblock %}
        <title>Hello, world!</title>
    </head>
{% block body %}
  {{block.super}}
    <br>
    <div class="form">
        {% load crispy_forms_tags %}
        <form method="post" action="" enctype=multipart/form-data>
            <div class="form-content">
                {% csrf_token %}
                {{ form|crispy }}
                <b>Image Preview:</b>
                <div id="image-holder"> </div>
                <button type="submit">Submit</button>
            </div>
        </form>
    </div>
{% endblock %}
</html>

article/templates/article_index.html
{% extends 'base.html' %}
{% load static %}
<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <!-- <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css" integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous"> --> -->
    {% block css %}
    {{block.super}}
    <link rel="stylesheet" href="{% static 'css/index.css' %}">
    {% endblock %}
    <title>Hello, world!</title>
  </head>
  {% block body %}
    {{block.super}}
    <!-- Option 1: jQuery and Bootstrap Bundle (includes Popper) -->
    <!-- <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ho+j7jyWK8fNQe+A12Hb8AhRq26LrZ/JpcUGGOn+Y7RsweNrtN/tE3MoK7ZeZDyx" crossorigin="anonymous"></script> -->

    <!-- <nav class="navbar navbar-expand-lg navbar-dark bg-primary">
        <a class="navbar-brand" href="#"><b>RuangSinggah<span id="titik" style="color: yellow;">.</span></b></a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNavAltMarkup" aria-controls="navbarNavAltMarkup" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarNavAltMarkup">
          <div class="navbar-nav">
            <a class="nav-link active" href="#"><b>Konsultasi</b> <span class="sr-only">(current)</span></a>
            <a class="nav-link" href="#"><b>Quiz</b></a>
            <a class="nav-link" href="#"><b>Diskusi</b></a>
            <a class="nav-link" href="#"><b>Donasi</b></a>
          </div>
        </div>
    </nav> -->
    <!-- <br> -->

    <div id="carouselExampleIndicators" class="carousel slide" data-ride="carousel">
      <ol class="carousel-indicators">
        <li data-target="#carouselExampleIndicators" data-slide-to="0" class="active"></li>
        <li data-target="#carouselExampleIndicators" data-slide-to="1"></li>
        <li data-target="#carouselExampleIndicators" data-slide-to="2"></li>
      </ol>
      <div class="carousel-inner">
        <div class="carousel-item active">
          <img src="{% static 'img/chat.png' %}" class="d-block w-100">
        </div>
        <div class="carousel-item">
          <img src="{% static 'img/test.png' %}" class="d-block w-100">
        </div>
        <div class="carousel-item">
          <img src="{% static 'img/money.png' %}" class="d-block w-100">
        </div>  
      </div>
      <a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
        <span class="carousel-control-prev-icon" aria-hidden="true" style="fill: black;"></span>
      </a>
      <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
        <span class="carousel-control-next-icon" aria-hidden="true"></span>
      </a>
    </div>
    <div class="main-content">
      <h2 style="display: inline-block;">Artikel terbaru untukmu!</h2>
      {% if request.user.is_authenticated %}
        {% if request.user.is_counselor or request.user.is_staff or request.user.is_superuser %}
        <a href="{% url 'article:add' %}" style="float: right;">Add Post</a>
        <a href="{% url 'article:admin_view' %}" style="float: right; margin-right: 2vw; ">Edit Post</a>
        {% endif %}
      {% endif %}
      {% for i in article %}
      <div class="article-box">
        <div class="pic">
          <img src="media/{{ BASIC_DIR }}/{{i.photo}}" alt="">
        </div>
      
        <div class="sub-content">
          <h3>{{i.title}}</h3>
          <h6>{{i.author}}</h6>
          <h6>{{i.date}}</h6>
          <p>{{i.desc}}</p>
          <a href="{% url 'article:singlePost' id=i.id  %}" class="btn btn-warning btn-sm">detail</a>
        </div>

      </div>
      {% endfor %}
    </div>
  {% endblock %}
    
    <!-- <div class="footer">
      <br>
      <h2>RuangSinggah<span style="color: yellow;">.</span></h2>
      <h4>Tempat bersinggah di kala sedih</h4>
      <br>
    </div> -->
  </body>
</html>

article/templates/single_article.html
{% extends 'base.html' %}
{% load static %}
<!doctype html>
<html lang="en">
  <head>
    {% block css %}
    {{block.super}}
    <link rel="stylesheet" href="{% static 'css/single_post.css' %}">
    {% endblock %}
    
    {% block body %}
      {{block.super}}
      <div class="content">
        <h2>{{post.title}}</h2>
        <h6>{{post.date}}</h6>
        <h6>{{post.author}}</h6>
        <img src="{{post.photo.url}}" alt="">
        <p>{{post.article}}</p>
      </div>
    {% endblock %}

</html>